#!/usr/bin/python3

import gi, os, signal, threading, sys, subprocess

gi.require_version('Gtk', '3.0')


from gi.repository import Gtk, Gdk, GLib, Gio, GObject
from gi.repository.GdkPixbuf import Pixbuf
from aptsources.sourceslist import SourcesList


from webengine.webview import WebviewEngine
from window import Window



# Used as a decorator to run things in the background
def run_async(func):
  def wrapper(*args, **kwargs):
    thread = threading.Thread(target=func, args=args, kwargs=kwargs)
    thread.daemon = True
    thread.start()
    return thread
  return wrapper

# Used as a decorator to run things in the main loop, from another thread
def idle(func):
  def wrapper(*args):
    GObject.idle_add(func, *args)
  return wrapper

def signal_handler(signum, _):
  print("")
  sys.exit(128 + signum)

signal.signal(signal.SIGINT, signal_handler)


class Application(object):
  def __init__(self):
    self.window = Window()
    self.webview = WebviewEngine(self)

    self.window.add(self.webview)

  def run(self):
    self.window.connect("destroy", self.close)
    self.window.show_all()
    Gtk.main()

  def close(self, win = None):
    print('朕要休息了~~~')
    Gtk.main_quit()



if __name__ == "__main__":
  codename = subprocess.getoutput("lsb_release -sc")

  
  print ("LSB codename: '%s'." % codename)
  # sys.exit(1)
    
  Application().run()

