/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/08/08 18:19:17
 */
import { html, css, Component } from 'wkit'

import '@bd/ui/icon/index.js'
import '@bd/ui/space/index.js'
import '@bd/ui/form/input.js'
import '@bd/ui/form/switch.js'
import '@bd/ui/form/button.js'

class Official extends Component {
  static props = {
    foo: ''
  }

  static styles = [
    css`
      :host {
        flex: 1;
      }
      .main {
        width: 100%;
        height: 100%;
        padding: 32px;
        color: var(--color-dark-1);
        background: #f0f0f0;
      }

      wc-input {
        flex: 1;
      }

      wc-button {
        width: 100%;
      }

      .card {
        width: 100%;
        padding: 12px;
        margin: 0 auto 24px;
        border: 0;
        box-shadow: 0 0 8px rgba(0, 0, 0, 0.075);
        background: #fff;
      }
      legend {
        -webkit-touch-callout: none;
        user-select: none;
        color: var(--color-dark-1);
        font-weight: bold;
      }
    `
  ]

  render() {
    return html`
      <main class="main">
        <fieldset class="card">
          <legend>镜像地址</legend>

          <wc-space>
            <span>主站(bookworm)</span>
            <wc-input value="https://mirrors.ustc.edu.cn"></wc-input>
          </wc-space>
        </fieldset>

        <fieldset class="card">
          <legend>额外配置</legend>
          <wc-space justify>
            <span>启用源码源</span>
            <wc-switch></wc-switch>
          </wc-space>
        </fieldset>

        <wc-button type="secondary">恢复默认设置</wc-button>
      </main>
    `
  }
}

Official.reg('official')
